/* 
 *     XaoS, a fast portable realtime fractal zoomer 
 *                  Copyright (C) 1996 by
 *
 *      Jan Hubicka          (hubicka@paru.cas.cz)
 *      Thomas Marsh         (tmarsh@austin.ibm.com)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
static char *helptext[] =
{
    "/*/*/# Welcome to ugly interface #\\*\\*\\",
    "     The best interface for zooming!   ",
    "***************************************",
    "buttons:                               ",
    "left-zoom in           right-zoom out  ",
    "middle(or left+right)-move             ",
    "keys:                                  ",
    "1-9 fractal type      A autopilot      ",
    "H help                C out coloring   ",
    "F In coloring         I plane switching",
    "S Save                P Palette        ",
    "Q Quit                M Mand/Julia     ",
    "= Resize              ? Status         ",
    "R Recalculate     Space redraw screen  ",
    "V Change driver       z interrupt      ",
    "L Status line                          ",
    "Up/Down-change zooming speed           ",
    "Left/Right-number of iterations        ",
    "                                       ",
    "(possible more keys in driver depended ",
    "                documentation)         ",
    "                                       ",
    "CONTENTS                               ",
    "=======                                ",
    " o Keys summary                        ",
    " o contents                            ",
    " o fractal type                        ",
    " o planes                              ",
    " o in coloring                         ",
    " o out coloring                        ",
    " o Mand/Julia                          ",
    " o Why ugly interface                  ",
    " o homepage                            ",
    " o Contact to author                   ",
    " o driver depended documentation       ",
    "                                       ",
    "                                       ",
    "                                       ",
    "FRACTAL TYPE                           ",
    "============                           ",
    "Fractal type may be changed by pressing",
    "number key when no menu is displayed.  ",
    "key  fractal                           ",
    " 1   Infamous fractal called Mandelbrot",
    "     set                               ",
    " 2-5 Mandelbrot set with higher power  ",
    "     Mandelbrot's formula is: z=z^2 + c",
    "     This fractals are same except ^2  ",
    "     is changed to ^3 and more         ",
    " 6   Octal. This is some infamous      ",
    "     Fractal that Thomas discovered in ",
    "     Fractint. Nice in other planes    ",
    " 7   Newton. This fractal uses old     ",
    "     famous formula for finding roots  ",
    "     of polygon discovered by Isaac.   ",
    " 8   Barnsley. Another formula that    ",
    "     comes from real world. But I      ",
    "     forgot what means :)              ",
    " 9   Phoenix. Very nice fractal.       ",
    "                                       ",
    "                                       ",
    "                                       ",
    "PLANES                                 ",
    "======                                 ",
    "All fractals displayed by XaoS are     ",
    "function with complex parameter.       ",
    "It can be displayed in normal complex  ",
    "plane where x is real part of number   ",
    "and y is imaginary. But may be also    ",
    "displayed in some more funny modes:    ",
    " 1   mu                                ",
    "      normal mode..                    ",
    " 2   1/mu                              ",
    "      Inversion-infinity is in 0 and   ",
    "      0 is in infinity.                ",
    " 3   1/(mu+0.25)                       ",
    "      Similar to inversion but moves   ",
    "      center outside of Mandelbrot     ",
    "      so it looks parabolic            ",
    " 4   lambda plane                      ",
    " 5   1/lambda                          ",
    " 6   1/lambda-1                        ",
    " 7   1/(mu-1.40115                     ",
    "      Very interesting mode for        ",
    "      Mandelbrot set. Makes small      ",
    "      thinks big. So you can           ",
    "      browse its details.              ",
    "                                       ",
    "                                       ",
    "                                       ",
    "OUT COLORING MODES                     ",
    "==================                     ",
    "Z value from last iteration is taken   ",
    "and used by some funny formula to      ",
    "modify color by some way to make it    ",
    "more interesting                       ",
    "                                       ",
    "                                       ",
    "                                       ",
    "IN COLORING MODES                      ",
    "=================                      ",
    "Similar as out-coloring modes but done ",
    "for points inside set.                 ",
    "                                       ",
    "                                       ",
    "                                       ",
    "MANDELBROT/JULIA                       ",
    "================                       ",
    "Most of fractals displayed by XaoS has ",
    "two forms-Mandelbrot and Julia.        ",
    "Every point in Mandelbrot version have ",
    "its own Julia set.                     ",
    "You may switch between them by key 'M' ",
    "Be careful in Mandelbrot to Julia      ",
    "switching, because you need to specify ",
    "point for Julia base. Most interesting ",
    "Julias has points at boundaries of set.",
    "So place pointer to some interesting   ",
    "place and press 'M'. Switching back    ",
    "switches always into same set.         ",
    "If set is in Mandelbrot or Julia mode  ",
    "is displayed in status line.           ",
    "                                       ",
    "                                       ",
    "                                       ",
    "WHY UGLY INTERFACE?                    ",
    "=====================                  ",
    "I know that only good, intuitive       ",
    "user interface can make program        ",
    "popular. So I decided to make          ",
    "__REALLY__ _REALLY_ good interface     ",
    "for XaoS. I started work at            ",
    "real-time ray-traced marble rotating   ",
    "buttons with metal shaded gothical     ",
    "gold letters and true-color 3d         ",
    "icons with fractal landscape           ",
    "reflecting inside. All of course       ",
    "with 3d 32 channel surround sound      ",
    "and for 3d monitor with special 3d     ",
    "mouse called batman.                   ",
    "But than something inside me said      ",
    "NO! You like vi, emacs, ed and use     ",
    "X only for starting xterm so           ",
    "why to make xaos different?            ",
    "All this programs has very             ",
    "powerful and simple user               ",
    "interface. So I started work on        ",
    "something minimal but powerful.        ",
    "And ugly interface is result!          ",
    "Of course main purpose is that I       ",
    "am lazy.                               ",
    "                                       ",
    "                                       ",
    "STATUS LINE                            ",
    "===========                            ",
    "This line contains few funny           ",
    "informations:                          ",
    " - how deep you are zoomed             ",
    " - how many frames per second          ",
    "   generated                           ",
    " - if autopilot is enabled             ",
    " - outcoloringmode,incoloringmode      ",
    "   plane and number of iterations      ",
    "                                       ",
    "                                       ",
    "                                       ",
    "HOMEPAGE                               ",
    "========                               ",
    "Additional informations, gallery, XaoS ",
    "sources, Possibly some kind of tutorial",
    "and much more can be found             ",
    "At xaos homepage:                      ",
    "http://www.paru.cas.cz/~hubicka/XaoS   ",
    "                                       ",
    "                                       ",
    "                                       ",
    "CONTACT TO AUTHORS:                    ",
    "==================                     ",
    "Jan Hubicka:                           ",
    "hubicka@paru.cas.cz in case of problems",
    "hubicka@tabor.ta.jcu.cz                ",
    "hubicka@atrey.karlin.mff.cuni.cz       ",
    "                                       ",
    "smail:                                 ",
    "                                       ",
    "Jan Hubicka                            ",
    "Dukelskych bojovniku 1944              ",
    "Tabor 390 03                           ",
    "Czech Republic                         ",
    "                                       ",
    "Thomas Marsh:                          ",
    "tmarsh@austin.ibm.com                  ",
    "                                       ",
    "                                       ",
    "                                       ",
    "All bug reports, flames, contributions,",
    "      thanks,etc.. welcomed!           ",
    "                                       ",
    "                                       ",
    "                                       ",

};
#define UGLYTEXTSIZE (sizeof(helptext)/sizeof(char *))
